<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  props: {
    startFret: { type: Number, required: true },
  },
  computed: {
    startFretClass() {
      return this.startFret > 0 ? "fret" : "nut";
    },
    fretNumbers() {
      const endFret = this.startFret + 5;
      const fretNumbers = [];
      if (this.startFret > 0) {
        for (let fretNo = this.startFret + 1; fretNo <= endFret; ++fretNo) {
          fretNumbers.push({
            y: 32 - 7 + (fretNo - this.startFret) * 18,
            no: fretNo,
          });
        }
      }
      return fretNumbers;
    },
  },
});
</script>
<template>
  <line x1="9.25" y1="31.6" x2="64.75" y2="31.6" :class="startFretClass" />
  <polyline points="10,32 10,122 64,122 64,32" class="fretboard" />
  <line x1="28" y1="32" x2="28" y2="122" class="string" />
  <line x1="46" y1="32" x2="46" y2="122" class="string" />
  <line x1="10" y1="50" x2="64" y2="50" class="fret" />
  <line x1="10" y1="68" x2="64.5" y2="68" class="fret" />
  <line x1="10" y1="86" x2="64.5" y2="86" class="fret" />
  <line x1="10" y1="104" x2="64.5" y2="104" class="fret" />

  <text
    class="fret_no"
    v-for="fretNumber in fretNumbers"
    x="70"
    :y="fretNumber.y"
    :key="fretNumber.no"
  >
    {{ fretNumber.no }}
  </text>
</template>
<style scoped>
.fret_no {
  alignment-baseline: middle;
  font-size: 0.7em;
  font-weight: bold;
  fill: #787c7e;
  font-family: verdana, sans-serif;
}

.fretboard {
  fill: none;
  stroke: #d3d6da;
  stroke-linejoin: round;
  stroke-width: 1.5;
}

.string,
.fret {
  stroke: #d3d6da;
  stroke-width: 1.5;
}

.nut {
  stroke: #d3d6da;
  stroke-width: 3.5;
}
</style>
